#! /usr/local/share/bin/perl
sub get_module_name {
    while (<>) {
	if (/^:- *macro_module *(\w*) *./) {
	    $module_name = $1;
	    return;
	}
    }
}

sub redirect {
    close(STDOUT);
    open(STDOUT, ">".$module_name.".h");
}

sub header {
    print "/*\n";
    print "  header file generated from macro module ", $1, "\n";
    print "*/\n\n";
}

sub print_definition {
    $a = $_[0]; $a =~ s/#/_hatch_/g;
    $a =~ s/{/(**/g; $a =~ s/}/**)/g;
    $a =~ s/\[/(++/g; $a =~ s/\]/++)/g;
    $b = $_[1]; $b =~ s/([^#])#([^#])/\1_hatch_##\2/g;
    $b =~ s/{/(**/g; $b =~ s/}/**)/g;
    $b =~ s/\[/(++/g; $b =~ s/\]/++)/g;
    printf "#if defined(__STDC__)\n";
    printf "#define %s %s\n", $a, $b;
    printf "#else\n";
    $b =~ s:##:/**/:g;
    printf "#define %s %s\n", $a, $b;
    printf "#endif\n";
}

sub access_write {
    &print_definition($_[0]."_hatch".$_[4]."(".$_[1].$_[5].")",
		      $_[2].$_[4]."(".$_[3].",".$_[5].")");
}

sub str_write {
    &access_write ($_[0], $_[1], $_[2], $_[3], "_new", "A");
    &access_write ($_[0], $_[1], $_[2], $_[3], "_is", "A");
    &access_write ($_[0], $_[1], $_[2], $_[3], "_gread", "A,B,C");
    &access_write ($_[0], $_[1], $_[2], $_[3], "_read", "A,B,C,D");
    &access_write ($_[0], $_[1], $_[2], $_[3], "_get", "A,B,C,D,E");
    &access_write ($_[0], $_[1], $_[2], $_[3], "_set", "A,B,C,D");
}

sub non_generic_str_write {
    &str_write($_[0], "", $_[1], $_[0]);
}

sub generic_str_write {
    &str_write($_[0], "Kind,", $_[1], $_[0]."_of_##Kind");
}

sub main {
    while (<>) {
        if (/^:- *inherit_macro(.*)./) {
	    @PARENTS = split(/,/,$1);
	    for ($i = 0; $i < @PARENTS; ++$i) {
	        $a = $PARENTS[$i];
		$a =~ s/\W*(\w*)\W*/\1/;
	        printf "#include \"%s.h\"\n", $a;
	    }
	} elsif (/^wrap#/) {
	    $buffer="";
	    while (! /\.\n/) {
		chop;
		$buffer = $buffer.$_;
		$_ = <>;
	    }
	    $_ = $buffer.$_;
	    if (/^wrap#\((\w+)#(.*)\)\s*=>\s*wrap#\((.+)\)./) {
		&print_definition($1."#".$2, $3);
	    } elsif (/^wrap#\((\w+)\((\w+)\)#(.*)\)\s*=>\s*wrap#\((.+)\)./) {
		if (! defined ($generic{$1.$3})) {
		    &print_definition($1."_hatch_".$3."(Kind)",
				      $1."_of_##Kind##_hatch_##".$3);
		    $generic{$1.$3} = 1;
		}
		&print_definition($1."_of_".$2."_hatch_".$3, $4);
	    }
	} elsif (/^type/) {
	    if (/^type\(wrap#\((\w+)\),\s*Type\)\s*:-\s*true\s*\|\s*Type\s*=\s*(\w+)\./) {
		&non_generic_str_write($1, $2);
	    } elsif (/^type\(wrap#\((\w+)\((\w+)\)\),\s*Type\)\s*:-\s*true\s*\|\s*Type\s*=\s*(\w+)\./) {
		&generic_str_write($1, $3);
	    }
	} elsif (/^:-\s*if_defined\(klic\)\./) {
            printf "#if 1\n";
        } elsif (/^:-\s*else./) {
            printf "#else\n";
        } elsif (/^:-\s*end_if./) {
            printf "#endif\n";
        }
    }
}

&get_module_name;
&redirect;
&header;
&main;
