#! /usr/local/bin/perl
$S = 1;
$MP = _MACRO_PREFIX_;

while (<>) {
  if (/^:-\s*define\s*\(\s*([^,]*)\s*,\s*([^\)]*)\s*\)\s*\./) {
    if (! defined $map{$2}) {
      $map{$2} = $S;
      if ($1 eq $2) {
	$_ = "#define $MP$2 $S\n";
      } else {
	$_ = "#define $MP$2 $S\n#define $MP$1 $MP$2\n";
      }
      $S++;
    } else {
      $_ = "#define $MP$1 $MP$2\n";
    }
  } elsif (/^:-\s*undefine\s*\(\s*([^\)]*)\s*\)\./) {
    $_ = "#undef $MP$1\n";
  } elsif (/^:-\s*if_equal\s*\(\s*([^,]*)\s*,\s*([^\)]*)\s*\)\./) {
    $_ = "#if $MP$1 == $MP$2\n";
  } elsif (/^:-\s*if_not_equal\s*\(\s*([^,]*)\s*,\s*([^\)]*)\s*\)\./) {
    $_ = "#if $MP$1 != $MP$2\n";
  } elsif (/^:-\s*if_defined\s*\(\s*([^\)]*)\s*\)\./) {
    $_ = "#if defined($MP$1)\n";
  } elsif (/^:-\s*if_not_defined*\(\s*([^\)]*)\s*\)\./) {
    $_ = "#if ! defined($MP$1)\n";
  } elsif (/^:-\s*else\s*./) {
    $_ = "#else\n";
  } elsif (/^:-\s*end_if\s*./) {
    $_ = "#endif\n";
  } elsif (/^:-\s*include*\(\s*([^\)]*)\s*\)\./) {
    $_ = "#include $1\n";
  } elsif (/^:-\s*switch\s*\(\s*([^\)]*)\s*\)\./) {
    $SV = "$MP$1";
    $SVF = 1;
    $_ = "";
  } elsif (/^:-\s*case\s*\(\s*([^\)]*)\s*\)\./) {
    if ($SVF == 1) {
      $_ = "#if $SV == $MP$1\n";
      $SVF = 0;
    } else {
      $_ = "#elif $SV == $MP$1\n";
    }
  } elsif (/^:-\s*default\s*./) {
    $_ = "#else\n";
  } elsif (/^:-\s*end_switch\s*./) {
    $_ = "#endif\n";
  }
  print $_;
}
